#include "Board.h"


Board::Board(void)
{
	// [6/5]Ֆʔz̏֐
	initBoard();
	// Ֆʍ쐬
	setupBoard();
}


Board::~Board(void)
{
}

void Board::initBoard(void)
{
	// z̏l-1(uĂȂ)ŏ
	for(int i = 0; i < 8; ++i) {
		for(int j = 0; j < 8; ++j) {
			cellInfo[i][j].index = -1;
			cellInfo[i][j].color = ST_DEFAULT;
		}
	}
}

void Board::entry(fk_Scene *argScene)
{
	argScene->entryModel(&blockModel);
	argScene->entryModel(&gridModel);

	return;
}

void Board::remove(fk_Scene *argScene)
{
	argScene->removeModel(&blockModel);
	argScene->removeModel(&gridModel);

	return;
}

void Board::setupBoard(void)
{
	// ̂̐ݒ
	block.makeBlock(90.0, 5.0, 90.0),
	blockModel.setShape(&block);
	blockModel.setMaterial(Green);
	blockModel.glTranslate(0.0, -2.75, 0.0);

	// Obh
	fk_Vector	posA, posB;
	for(int i = 0; i < 9; ++i) {
		posA.set(-40.0 + i*10.0, 0.0, -40.0);
		posB.set(-40.0 + i*10.0, 0.0,  40.0);
		grid.pushLine(posA, posB);
		posA.set(-40.0, 0.0, -40.0 + i*10.0);
		posB.set( 40.0, 0.0, -40.0 + i*10.0);
		grid.pushLine(posA, posB);
	}
	gridModel.setShape(&grid);
	gridModel.setLineColor(0.0, 0.0, 0.0);
	gridModel.setWidth(2.0);

	return;
}

int Board::checkCell(const fk_Vector &argPos, fk_Vector *argAdjustPos)
{
	// ␳̗
	int tmpX = (int)argPos.x;
	int tmpZ = (int)argPos.z;
	if(tmpX > 0) {
		argAdjustPos->x = tmpX - (tmpX % 10) + 5;
	} else {
		argAdjustPos->x = tmpX - (tmpX % 10) - 5;
	}
	if(tmpZ > 0) {
		argAdjustPos->z = tmpZ - (tmpZ % 10) + 5;
	} else {
		argAdjustPos->z = tmpZ - (tmpZ % 10) - 5;
	}
	argAdjustPos->y = 0.0;

	// -35.0`35.0̎l0`7ɒ(z̗vfԍƂėp)
	CellPosition	pos = calcID(*argAdjustPos);

	// ͈͊O`FbN
	if(pos.x == -1) {
		return -2;
	}

	// ɒuĂ邩`FbN
	if(cellInfo[pos.x][pos.y].index >= 0) {
		return cellInfo[pos.x][pos.y].index;
	}

	return -1;
}

// ̐΂ӂɂ邩𒲂ׂ֐
bool Board::checkAround(StoneColor argColor, const fk_Vector &argPos)
{
	// -35.0`35.0̎l0`7ɒ(z̗vfԍƂėp)
	CellPosition	pos = calcID(argPos);

	// ͈͊O`FbN
	if(pos.x == -1) {
		return false;
	}

	StoneColor	oppositeColor = Stone::opposite(argColor);

	CellPosition	aroundPos;
	for(int i = -1; i <= 1; ++i) {
		aroundPos.x = pos.x + i;
		if(aroundPos.x < 0 || aroundPos.x > 7) continue;
		for(int j = -1; j <= 1; ++j) {
			if(i == 0 && j == 0) continue;
			aroundPos.y = pos.y + j;
			if(aroundPos.y < 0 || aroundPos.y > 7) continue;
			if(cellInfo[aroundPos.x][aroundPos.y].color == oppositeColor) {
				return true;
			}
		}
	}

	return false;
}

void Board::setStoneID(const fk_Vector &argPos, int argID, StoneColor argColor)
{
	// -35.0`35.0̎l0`7ɒ(z̗vfԍƂėp)
	CellPosition	pos = calcID(argPos);
	// ͈͊O`FbN
	if(pos.x == -1) {
		return;
	}

	cellInfo[pos.x][pos.y].index = argID;
	if(argColor == ST_DEFAULT) {
		cellInfo[pos.x][pos.y].color = Stone::opposite(cellInfo[pos.x][pos.y].color);
	} else {
		cellInfo[pos.x][pos.y].color = argColor;
	}

	return;
}

// -35`35̍Wl0`7ɕϊ
CellPosition Board::calcID(const fk_Vector &argPos)
{
	CellPosition	pos;
	pos.x = (int)(argPos.x + 35)/10;
	pos.y = (int)(argPos.z + 35)/10;

	// ͈͊O`FbN
	if(pos.x < 0 || pos.x > 7 || pos.y < 0 || pos.y > 7) {
		pos.x = pos.y = -1;
	}

	return pos;
}
