#include "Stone.h"


StoneColor Stone::opposite(StoneColor argColor)
{
	return (argColor == ST_BLACK) ? ST_WHITE : ST_BLACK;
}

Stone::Stone(StoneColor argColor) : color(argColor)
{
	// ΂̊{`̓vY1g񂷂Ƃɂ
	stoneShape.makePrism(32, 4.0, 4.0, 0.25);
	// fɌ`ƃXP[Zbg
	blackModel.setShape(&stoneShape);
	blackModel.setSmoothMode(true);
	blackModel.setMaterial(GlossBlack);
	blackModel.glMoveTo(0.0, 0.0, -0.25);
	whiteModel.setShape(&stoneShape);
	whiteModel.setSmoothMode(true);
	whiteModel.setMaterial(White);
	blackModel.glMoveTo(0.0, 0.0,  0.25);
	
	blackModel.setParent(&stoneModel, true);
	whiteModel.setParent(&stoneModel, true);

	if(color == ST_BLACK) {
		stoneModel.glVec(0.0, -1.0, 0.0);
		cout << "͍" << endl;
	} else if(color == ST_WHITE) {
		stoneModel.glVec(0.0,  1.0, 0.0);
		cout << "͔" << endl;
	} else {
		fl_alert("Invalid color!");
	}

	spinRad = 0.0;

	return;
}

Stone::~Stone(void)
{
}

// [6/5]Aj[V̂߁AlύXăAj[VgK[
void Stone::reverse(StoneColor argColor)
{
	if(argColor == ST_BLACK) {
		color = ST_BLACK;
	} else if(argColor == ST_WHITE) {
		color = ST_WHITE;
	} else {
		color = opposite(color);
	}
	spinRad += 0.1;

	return;
}

void Stone::setPosition(const fk_Vector &argPos)
{
	stoneModel.glMoveTo(argPos);
}

void Stone::entry(fk_Scene *argScene)
{
	argScene->entryModel(&blackModel);
	argScene->entryModel(&whiteModel);
}

void Stone::remove(fk_Scene *argScene)
{
	argScene->removeModel(&blackModel);
	argScene->removeModel(&whiteModel);
}

// [6/5]Aj[V
void Stone::update(void)
{
	double scaleAnime = double(fk_Window::getNow()%(31415*2))/10000.0;
	stoneModel.setScale(0.8 + fabs(cos(scaleAnime*25.0))*0.2);

	// spinRad0傫ƂAj[V
	if(spinRad > 0.0) {
		fk_Vector pos = stoneModel.getPosition();
		// XS0.1WA]
		stoneModel.glRotateWithVec(pos, fk_X, 1.0);
		// Ysin()gĈړxNg𔭐
		stoneModel.glMoveTo(pos.x, sin(spinRad)*50.0, pos.z);
		// Aj[Vi߂
		spinRad += 0.1;
		// PI]0WAɖ߂Aʂ̌m肳
		if(spinRad > FK_PI) {
			spinRad = 0.0;
			// n␳
			fk_Vector tmpPos = stoneModel.getPosition();
			stoneModel.glTranslate(0.0, -tmpPos.y, 0.0);
			if(color == ST_BLACK) {
				stoneModel.glVec(0.0, -1.0, 0.0);
			} else {
				stoneModel.glVec(0.0,  1.0, 0.0);
			}
		}
	}
	return;
}

// ʒu擾
fk_Vector Stone::getPosition(void)
{
	return stoneModel.getPosition();
}

// F擾
StoneColor Stone::getColor(void)
{
	return color;
}
